; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      Edit1Proc PROTO :DWORD,:DWORD,:DWORD,:DWORD
 
    .data?
      hWnd      dd ?
      hInstance dd ?
      hEdit1    dd ?        ;
      hEdit2    dd ?        ; create 3 edit control handles
      hEdit3    dd ?        ;
      lpEdit1Proc dd ?      ; variable for original message handler for the edit control

    .code

; 

start:
  
      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    invoke DialogBoxParam,hInstance,1000,0,ADDR DlgProc,0

    ret

main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
 
    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)

        fn SetWindowText,hWin,"Superclass with a single subclass"
      ; ------------------------------------
      ; get each edit handle and subclass it
      ; ------------------------------------
        invoke GetDlgItem,hWin,100
        mov hEdit1, eax
        invoke SetWindowLong,hEdit1,GWL_WNDPROC,Edit1Proc
        mov lpEdit1Proc, eax

        invoke GetDlgItem,hWin,101
        mov hEdit2, eax
        invoke SetWindowLong,hEdit2,GWL_WNDPROC,Edit1Proc
        mov lpEdit1Proc, eax

        invoke GetDlgItem,hWin,102
        mov hEdit3, eax
        invoke SetWindowLong,hEdit3,GWL_WNDPROC,Edit1Proc
        mov lpEdit1Proc, eax

        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case IDOK
            jmp quit_dialog
        EndSw

      Case WM_CLOSE
        quit_dialog:
         invoke EndDialog,hWin,0
    EndSw

    xor eax, eax        ; important to return ZERO
    ret

DlgProc endp

; 

Edit1Proc proc hCtl   :DWORD,
               uMsg   :DWORD,
               wParam :DWORD,
               lParam :DWORD

  ; -----------------------------
  ; Process control messages here
  ; -----------------------------

    .if uMsg == WM_CHAR
      .if wParam < 48 || wParam > 57    ; only allow numbers
        ret
      .endif 

    .endif

  ; ----------------------------------------------------------------
  ; notice on the following line that the function must be told
  ; where to return to which happens to be the address of the default
  ; message handler for each edit control as it has been set above.
  ; ----------------------------------------------------------------

    invoke CallWindowProc,lpEdit1Proc,hCtl,uMsg,wParam,lParam

    ret

Edit1Proc endp

; 

end start
